﻿Import-Module SQLPS;
Import-Module FailoverClusters;

$NodesList = {"SQL2K16-AG01"}, {"SQL2K16-AG02"}, {"SQL2K16-AG03"}
$DatabaseList = "AdventureWorks2017"

foreach ($Node in $NodesList)
{}

$Node = $env:COMPUTERNAME

# Failover clustering Features Installed
Invoke-Command -ScriptBlock {
if (!(Get-WindowsFeature Failover*).Installed)
{    
    Install-WindowsFeature Failover-Clustering
}

if(!(Get-WindowsFeature RSAT-Clustering-MGMT).Installed)
{
    Install-WindowsFeature RSAT-Clustering-MGMT
}

if(!(Get-WindowsFeature RSAT-Clustering-PowerShell).Installed)
{
    Install-WindowsFeature RSAT-Clustering-PowerShell
}

}

Remove-Cluster -Force;

New-Cluster -Name SQL2K16-AGClust -Node SQL2K16-AG01,SQL2K16-AG02 -NoStorage -StaticAddress 192.168.10.250 

# Disable the AlwaysOn Service on each cluster node
Get-ClusterNode | % { Disable-SqlAlwaysOn -ServerInstance $_.Name -Force; }

# Enable the AlwaysOn Service on each cluster node
Get-ClusterNode | % { Enable-SqlAlwaysOn -ServerInstance $_.Name -Force; }


Install-ADServiceAccount gMSAsqlservice
Test-ADServiceAccount gMSAsqlservice


