--- YOU MUST EXECUTE THE FOLLOWING SCRIPT IN SQLCMD MODE.
:CONNECT SQL2K16-AG01
ALTER AVAILABILITY GROUP [SQL2K16-AG1] FAILOVER;
GO

:CONNECT SQL2K16-AG01

-- Delete Backups
EXECUTE sp_configure 'show advanced options', 1; RECONFIGURE;
EXECUTE sp_configure 'xp_cmdshell', 1; RECONFIGURE; 
EXEC xp_cmdshell 'DEL C:\Backups\ConfigDB*';
EXEC xp_cmdshell 'DEL C:\Backups\ERPDatabase*';

EXEC xp_cmdshell 'DEL \\SQL2K16-AG03\LogShipping\ConfigDB\*.trn';
EXEC xp_cmdshell 'DEL \\SQL2K16-AG03\LogShipping\ERPDatabase\*.trn';
EXEC xp_cmdshell 'DEL \\SQL2K16-AG03\LogShipping\AdventureWorks2012\*.trn';
EXEC xp_cmdshell 'DEL \\SQL2K16-AG03\LogShipping\TLOGS\*.trn';
EXEC xp_cmdshell 'DEL \\SQL2K16-AG03\LogShipping\*.bak';

EXECUTE sp_configure 'xp_cmdshell', 0; RECONFIGURE;
EXECUTE sp_configure 'show advanced options', 0; RECONFIGURE;
GO

DECLARE @Drop_AGs NVARCHAR(MAX) = ''

SELECT @Drop_AGs = 'DROP AVAILABILITY GROUP ' + QUOTENAME(name) + ';
'
FROM sys.availability_groups;

EXECUTE (@Drop_AGs);
GO
DROP ENDPOINT [Hadr_endpoint]
GO

IF DB_ID('ConfigDB') IS NOT NULL
BEGIN
	ALTER DATABASE [ConfigDB] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ConfigDB];
END
IF DB_ID('ERPDatabase') IS NOT NULL
BEGIN
	ALTER DATABASE [ERPDatabase] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ERPDatabase];
END

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'ERPLogin')
BEGIN
	DROP LOGIN [ERPLogin]
END
GO

USE [master]
GO
CREATE LOGIN [ERPLogin] WITH PASSWORD=N'12345', DEFAULT_DATABASE=[master], CHECK_EXPIRATION=OFF, CHECK_POLICY=OFF
GO

CREATE DATABASE [ERPDatabase]
GO
ALTER DATABASE [ERPDatabase] SET RECOVERY FULL 
GO

CREATE DATABASE [ConfigDB]
GO
ALTER DATABASE [ConfigDB] SET RECOVERY FULL 
GO

USE [ConfigDB]
GO
CREATE USER [ERPLogin] FOR LOGIN [ERPLogin]
ALTER ROLE [db_owner] ADD MEMBER [ERPLogin]
GO

USE [ERPDatabase]
GO
CREATE USER [ERPLogin] FOR LOGIN [ERPLogin]
ALTER ROLE [db_owner] ADD MEMBER [ERPLogin]
GO

USE [ConfigDB]
GO
CREATE TABLE InsertCount (RowID int identity primary key)
GO
INSERT INTO InsertCount DEFAULT VALUES;
GO

BACKUP DATABASE [ConfigDB] TO DISK=N'NUL'
GO
BACKUP DATABASE [ERPDatabase] TO DISK=N'NUL'
GO

IF DB_ID('AdventureWorks2012') IS NOT NULL
BEGIN
	IF ((SELECT state_desc FROM sys.databases WHERE name = 'AdventureWorks2012') != 'ONLINE')
		RESTORE DATABASE [AdventureWorks2012] WITH RECOVERY;
END
GO

EXEC sys.sp_configure N'contained database authentication', N'0'
GO
RECONFIGURE WITH OVERRIDE
GO

USE [msdb]
GO

/****** Object:  Job [ConfigDB Log Backup]    Script Date: 3/24/2012 7:12:47 PM ******/
EXEC msdb.dbo.sp_delete_job @job_name='ConfigDB Log Backup', @delete_unused_schedule=1
GO

use msdb
GO
DECLARE @job_id uniqueidentifier 
SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
WHILE @job_id IS NOT NULL
BEGIN 
EXECUTE sp_delete_job @job_id = @job_id, @delete_history = 1, @delete_unused_schedule = 1;

SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
END

USE [master]
GO
IF OBJECT_ID('BackupTransactionLogs') IS NOT NULL
BEGIN
	DROP PROCEDURE BackupTransactionLogs;
END
GO

EXECUTE sp_cycle_errorlog;
GO

:CONNECT SQL2K16-AG02

DROP ENDPOINT [Hadr_endpoint]
GO

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'DWUser')
BEGIN
	DROP LOGIN [DWUser]
END
GO

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'ERPLogin')
BEGIN
	DROP LOGIN [ERPLogin]
END
GO

IF DB_ID('ConfigDB') IS NOT NULL
BEGIN
	ALTER DATABASE [ConfigDB] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ConfigDB];
END
IF DB_ID('ERPDatabase') IS NOT NULL
BEGIN
	ALTER DATABASE [ERPDatabase] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ERPDatabase]
END
IF DB_ID('AdventureWorks2012') IS NOT NULL
BEGIN
	ALTER DATABASE [AdventureWorks2012] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [AdventureWorks2012]
END
GO

EXEC sys.sp_configure N'contained database authentication', N'0'
GO
RECONFIGURE WITH OVERRIDE
GO

USE [msdb]
GO

/****** Object:  Job [ConfigDB Log Backup]    Script Date: 3/24/2012 7:12:47 PM ******/
EXEC msdb.dbo.sp_delete_job @job_name='ConfigDB Log Backup', @delete_unused_schedule=1
GO

use msdb
GO
DECLARE @job_id uniqueidentifier 
SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
WHILE @job_id IS NOT NULL
BEGIN 
EXECUTE sp_delete_job @job_id = @job_id, @delete_history = 1, @delete_unused_schedule = 1;

SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
END

USE [master]
GO
IF OBJECT_ID('BackupTransactionLogs') IS NOT NULL
BEGIN
	DROP PROCEDURE BackupTransactionLogs;
END
GO

EXECUTE sp_cycle_errorlog;
GO

:CONNECT SQL2K16-AG03

DROP ENDPOINT [Hadr_endpoint]
GO

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'DWUser')
BEGIN
	DROP LOGIN [DWUser]
END
GO

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'ERPLogin')
BEGIN
	DROP LOGIN [ERPLogin]
END
GO

IF DB_ID('ConfigDB') IS NOT NULL
BEGIN
	ALTER DATABASE [ConfigDB] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ConfigDB];
END
IF DB_ID('ERPDatabase') IS NOT NULL
BEGIN
	ALTER DATABASE [ERPDatabase] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [ERPDatabase]
END
IF DB_ID('AdventureWorks2012') IS NOT NULL
BEGIN
	ALTER DATABASE [AdventureWorks2012] SET SINGLE_USER WITH ROLLBACK IMMEDIATE;
	DROP DATABASE [AdventureWorks2012]
END
GO
EXEC sys.sp_configure N'contained database authentication', N'0'
GO
RECONFIGURE WITH OVERRIDE
GO

USE [msdb]
GO

/****** Object:  Job [ConfigDB Log Backup]    Script Date: 3/24/2012 7:12:47 PM ******/
EXEC msdb.dbo.sp_delete_job @job_name='ConfigDB Log Backup', @delete_unused_schedule=1
GO

use msdb
GO
DECLARE @job_id uniqueidentifier 
SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
WHILE @job_id IS NOT NULL
BEGIN 
EXECUTE sp_delete_job @job_id = @job_id, @delete_history = 1, @delete_unused_schedule = 1;

SELECT @job_id = MIN(job_id) from sysjobs where category_id = 6
END

USE [master]
GO
IF OBJECT_ID('BackupTransactionLogs') IS NOT NULL
BEGIN
	DROP PROCEDURE BackupTransactionLogs;
END
GO

EXECUTE sp_cycle_errorlog;
GO


--- YOU MUST EXECUTE THE FOLLOWING SCRIPT IN SQLCMD MODE.
:Connect SQL2K16-AG01

USE [master]

GO

CREATE ENDPOINT [Hadr_endpoint] 
	AS TCP (LISTENER_PORT = 5022)
	FOR DATA_MIRRORING (ROLE = ALL, ENCRYPTION = REQUIRED ALGORITHM AES)

GO

IF (SELECT state FROM sys.endpoints WHERE name = N'Hadr_endpoint') <> 0
BEGIN
	ALTER ENDPOINT [Hadr_endpoint] STATE = STARTED
END


GO

use [master]

GO

GRANT CONNECT ON ENDPOINT::[Hadr_endpoint] TO [SQLskillsDemos\gMSAsqlservice$]

GO

:Connect SQL2K16-AG01

IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='AlwaysOn_health')
BEGIN
  ALTER EVENT SESSION [AlwaysOn_health] ON SERVER WITH (STARTUP_STATE=ON);
END
IF NOT EXISTS(SELECT * FROM sys.dm_xe_sessions WHERE name='AlwaysOn_health')
BEGIN
  ALTER EVENT SESSION [AlwaysOn_health] ON SERVER STATE=START;
END

GO

:Connect SQL2K16-AG02

USE [master]

GO

CREATE ENDPOINT [Hadr_endpoint] 
	AS TCP (LISTENER_PORT = 5022)
	FOR DATA_MIRRORING (ROLE = ALL, ENCRYPTION = REQUIRED ALGORITHM AES)

GO

IF (SELECT state FROM sys.endpoints WHERE name = N'Hadr_endpoint') <> 0
BEGIN
	ALTER ENDPOINT [Hadr_endpoint] STATE = STARTED
END


GO

use [master]

GO

GRANT CONNECT ON ENDPOINT::[Hadr_endpoint] TO [SQLskillsDemos\gMSAsqlservice$]

GO

:Connect SQL2K16-AG02

IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='AlwaysOn_health')
BEGIN
  ALTER EVENT SESSION [AlwaysOn_health] ON SERVER WITH (STARTUP_STATE=ON);
END
IF NOT EXISTS(SELECT * FROM sys.dm_xe_sessions WHERE name='AlwaysOn_health')
BEGIN
  ALTER EVENT SESSION [AlwaysOn_health] ON SERVER STATE=START;
END

GO

:Connect SQL2K16-AG01

USE [master]

GO

CREATE AVAILABILITY GROUP [SQL2K16-AG1]
WITH (AUTOMATED_BACKUP_PREFERENCE = SECONDARY,
DB_FAILOVER = OFF,
DTC_SUPPORT = NONE)
FOR DATABASE [AdventureWorks2012], [ConfigDB], [ERPDatabase]
REPLICA ON N'SQL2K16-AG01' WITH (ENDPOINT_URL = N'TCP://SQL2K16-AG01.SQLskillsDemos.com:5022', FAILOVER_MODE = AUTOMATIC, AVAILABILITY_MODE = SYNCHRONOUS_COMMIT, BACKUP_PRIORITY = 50, SEEDING_MODE = AUTOMATIC, SECONDARY_ROLE(ALLOW_CONNECTIONS = ALL)),
	N'SQL2K16-AG02' WITH (ENDPOINT_URL = N'TCP://SQL2K16-AG02.SQLskillsDemos.com:5022', FAILOVER_MODE = AUTOMATIC, AVAILABILITY_MODE = SYNCHRONOUS_COMMIT, BACKUP_PRIORITY = 50, SEEDING_MODE = AUTOMATIC, SECONDARY_ROLE(ALLOW_CONNECTIONS = ALL));

GO

ALTER AVAILABILITY GROUP [SQL2K16-AG1] SET(
AUTOMATED_BACKUP_PREFERENCE = PRIMARY
);
GO
:Connect SQL2K16-AG01

USE [master]

GO

ALTER AVAILABILITY GROUP [SQL2K16-AG1]
ADD LISTENER N'SQL2K16-AGL1' (
WITH IP
((N'192.168.10.35', N'255.255.255.0')
)
, PORT=1433);

GO

:Connect SQL2K16-AG02

ALTER AVAILABILITY GROUP [SQL2K16-AG1] JOIN;

GO

ALTER AVAILABILITY GROUP [SQL2K16-AG1] GRANT CREATE ANY DATABASE;

GO



GO


